## libdfp 1.0.17

=== base-math/Makefile ===
# Copyright (C) 2015 Free Software Foundation, Inc.
#
# This file is part of the Decimal Floating Point C Library.
#
# The Decimal Floating Point C Library is free software; you can
# redistribute it and/or modify it under the terms of the GNU Lesser
# General Public License version 2.1.
#
# The Decimal Floating Point C Library is distributed in the hope that
# it will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
# the GNU Lesser General Public License version 2.1 for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License version 2.1 along with the Decimal Floating Point C Library;
# if not, write to the Free Software Foundation, Inc., 51 Franklin
# Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please see libdfp/COPYING.txt for more information.  */

# These are compat implementations for unfortunate users of binaries
# which cannot be rebuilt to support native DFP
# See sysdeps/dpd/Makefile for inclusion.

=== decNumberMath/Makefile ===
# Copyright (C) 2015 Free Software Foundation, Inc.
#
# This file is part of the Decimal Floating Point C Library.
#
# The Decimal Floating Point C Library is free software; you can
# redistribute it and/or modify it under the terms of the GNU Lesser
# General Public License version 2.1.
#
# The Decimal Floating Point C Library is distributed in the hope that
# it will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
# the GNU Lesser General Public License version 2.1 for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License version 2.1 along with the Decimal Floating Point C Library;
# if not, write to the Free Software Foundation, Inc., 51 Franklin
# Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please see libdfp/COPYING.txt for more information.  */

libdfp_files += decNumberMath

=== ieee754r/Makefile ===
# Copyright (C) 2015 Free Software Foundation, Inc.
#
# This file is part of the Decimal Floating Point C Library.
#
# The Decimal Floating Point C Library is free software; you can
# redistribute it and/or modify it under the terms of the GNU Lesser
# General Public License version 2.1.
#
# The Decimal Floating Point C Library is distributed in the hope that
# it will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
# the GNU Lesser General Public License version 2.1 for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License version 2.1 along with the Decimal Floating Point C Library;
# if not, write to the Free Software Foundation, Inc., 51 Franklin
# Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please see libdfp/COPYING.txt for more information.  */

libdfp_files +=	acosd32 acosd64 acosd128 \
		acoshd32 acoshd64 acoshd128 \
		asind32 asind64 asind128 \
		asinhd32 asinhd64 asinhd128 \
		atan2d32 atan2d64 atan2d128 \
		atand32 atand64 atand128 \
		atanhd32 atanhd64 atanhd128 \
		cbrtd32 cbrtd64 cbrtd128 \
		ceild32 ceild64 ceild128 \
		copysignd32 copysignd64 copysignd128 \
		cosd32 cosd64 cosd128 \
		coshd32 coshd64 coshd128 \
		erfd32 erfd64 erfd128 \
		exp2d32 exp2d64 exp2d128 \
		expd32 expd64 expd128 \
		expm1d32 expm1d64 expm1d128 \
		fabsd32 fabsd64 fabsd128 \
		fdimd32 fdimd64 fdimd128 \
		isfinited32 isfinited64 isfinited128 \
		issignalingd32 issignalingd64 issignalingd128 \
		floord32 floord64 floord128 \
		fmad32 fmad64 fmad128 \
		fmaxd32 fmaxd64 fmaxd128 \
		fmind32 fmind64 fmind128 \
		fmodd32 fmodd64 fmodd128 \
		fpclassifyd32 fpclassifyd64 fpclassifyd128 \
		frexpd32 frexpd64 frexpd128 \
		hypotd32 hypotd64 hypotd128 \
		ilogbd32 ilogbd64 ilogbd128 \
		llogbd32 llogbd64 llogbd128 \
		isgreaterd32 isgreaterd64 isgreaterd128 \
		isgreaterequald32 isgreaterequald64 isgreaterequald128 \
		isinfd32 isinfd64 isinfd128 \
		islessd32 islessd64 islessd128 \
		islessequald32 islessequald64 islessequald128 \
		islessgreaterd32 islessgreaterd64 islessgreaterd128 \
		isnand32 isnand64 isnand128 \
		isnormald32 isnormald64 isnormald128 \
		isunorderedd32 isunorderedd64 isunorderedd128 \
		ldexpd32 ldexpd64 ldexpd128 \
		lgammad32 lgammad64 lgammad128 \
		llquantexpd32 llquantexpd64 llquantexpd128 \
		llrintd32 llrintd64 llrintd128 \
		llroundd32 llroundd64 llroundd128 \
		log10d32 log10d64 log10d128 \
		log1pd32 log1pd64 log1pd128 \
		log2d32 log2d64 log2d128 \
		logbd32 logbd64 logbd128 \
		logd32 logd64 logd128 \
		lrintd32 lrintd64 lrintd128 \
		lroundd32 lroundd64 lroundd128 \
		modfd32 modfd64 modfd128 \
		nand32 nand64 nand128 \
		nearbyintd32 nearbyintd64 nearbyintd128 \
		nextafterd32 nextafterd64 nextafterd128 \
		nexttowardd32 nexttowardd64 nexttowardd128 \
		powd32 powd64 powd128 \
		quantized32 quantized64 quantized128 \
		quantumd32 quantumd64 quantumd128 \
		remainderd32 remainderd64 remainderd128 \
		rintd32 rintd64 rintd128 \
		roundd32 roundd64 roundd128 \
		roundevend32 roundevend64 roundevend128 \
		samequantumd32 samequantumd64 samequantumd128 \
		scalblnd32 scalblnd64 scalblnd128 \
		scalbnd32 scalbnd64 scalbnd128 \
		signbitd32 signbitd64 signbitd128 \
		sind32 sind64 sind128 \
		sinhd32 sinhd64 sinhd128 \
		sqrtd32 sqrtd64 sqrtd128 \
		tand32 tand64 tand128 \
		tanhd32 tanhd64 tanhd128 \
		tgammad32 tgammad64 tgammad128 \
		truncd32 truncd64 truncd128 \
		fmaxmagd32 fmaxmagd64 fmaxmagd128 \
		fminmagd32 fminmagd64 fminmagd128 \
		nextupd32 nextupd64 nextupd128 \
		nextdownd32 nextdownd64 nextdownd128

=== libbid/Makefile ===
libdfp_files += _addsub_dd _dd_to_sf _dd_to_xf _di_to_td _eq_td _gt_td \
				_le_td _mul_td _sd_to_di _sd_to_usi _si_to_sd _td_to_sf \
				_tf_to_dd _unord_dd _xf_to_dd _addsub_sd _dd_to_si \
				_df_to_dd _div_dd _ge_dd _lt_dd _ne_dd _sd_to_sf _sd_to_xf \
				_si_to_td _td_to_si _tf_to_sd _unord_sd _xf_to_sd _addsub_td \
				_dd_to_td _df_to_sd _div_sd _ge_sd _lt_sd _ne_sd _sd_to_si \
				_sf_to_dd _td_to_dd _td_to_tf _tf_to_td _unord_td _xf_to_td \
				_dd_to_df _dd_to_tf _df_to_td _div_td _ge_td _lt_td _ne_td \
				_sd_to_td _sf_to_sd _td_to_df _td_to_udi _udi_to_dd _usi_to_dd \
				_dd_to_di _dd_to_udi _di_to_dd _eq_dd _gt_dd _le_dd _mul_dd \
				_sd_to_dd _sd_to_tf _sf_to_td _td_to_di _td_to_usi _udi_to_sd \
				_usi_to_sd _dd_to_sd _dd_to_usi _di_to_sd _eq_sd _gt_sd _le_sd \
				_mul_sd _sd_to_df _sd_to_udi _si_to_dd _td_to_sd _td_to_xf \
				_udi_to_td _usi_to_td _dd_to_hf _hf_to_dd _hf_to_sd _hf_to_sd \
				_hf_to_td _sd_to_hf _td_to_hf

libdfp_files += bid_decimal_globals bid_decimal_data \
         bid_binarydecimal bid_convert_data \
         _isinfd32 _isinfd64 _isinfd128 bid64_noncomp \
         bid128_noncomp bid128_fma bid_round bid_from_int \
         bid64_add bid128_add bid64_div bid128_div \
         bid64_mul bid128_mul bid64_compare bid128_compare \
         bid128 bid32_to_bid64 bid32_to_bid128 bid64_to_bid128 \
         bid64_to_int32 bid64_to_int64 \
         bid64_to_uint32 bid64_to_uint64 \
         bid128_to_int32 bid128_to_int64 \
         bid128_to_uint32 bid128_to_uint64

# Ensure rounding mode is per-thread.
# TODO: Should this be via autoconf instead?
sysdeps-CFLAGS += -DUSE_TLS -DHAVE_CC_TLS

# TODO: TImode and TFmode support are missing from the above.
# for now, use BID -> decnumber
ifeq ($(libdfp-has-timode),yes)
libdfp_files += fixsdti fixddti \
		   fixunssdti fixunsddti \
		   fixtdti fixunstdti \
		   floattitd floatunstitd \
		   floattidd floatunstidd \
		   floattisd floatunstisd
endif

=== tests/Makefile ===
libdfp_c_tests = test-printf test-amort test-decode test-inexact-exception \
		 test-strtod test-cast-to-overflow test-numdigits test-get_digits \
		 test-fenv test-bfp-conversions test-type-conversions test-wchar \
		 test-getexp test-setexp test-left_justify test-cast-to-underflow \
		 test-fpclassify-d32 test-fpclassify-d64 test-fpclassify-d128 \
		 test-fabs-d32 test-fabs-d64 test-fabs-d128 \
		 test-copysign-d32 test-copysign-d64 test-copysign-d128 \
		 test-quantum-d32 test-quantum-d64 test-quantum-d128 \
		 test-quantize-d32 test-quantize-d64 test-quantize-d128 \
		 test-samequantum-d32 test-samequantum-d64 test-samequantum-d128 \
		 test-logb-d32 test-logb-d64 test-logb-d128 \
		 test-llquantexp-d32 test-llquantexp-d64 test-llquantexp-d128 \
		 test-isnan-d32 test-isnan-d64 test-isnan-d128 \
		 test-isnan_internal-d32 test-isnan_internal-d64 test-isnan_internal-d128 \
		 test-isinf-d32 test-isinf-d64 test-isinf-d128 \
		 test-isfinite-d32 test-isfinite-d64 test-isfinite-d128 \
		 test-issignaling-d32 test-issignaling-d64 test-issignaling-d128 \
		 test-ceil-d32 test-ceil-d64 test-ceil-d128 \
		 test-floor-d32 test-floor-d64 test-floor-d128 \
		 test-nearbyint-d32 test-nearbyint-d64 test-nearbyint-d128 \
		 test-round-d32 test-round-d64 test-round-d128 \
		 test-roundeven-d32 test-roundeven-d64 test-roundeven-d128 \
		 test-trunc-d32 test-trunc-d64 test-trunc-d128 \
		 test-isgreater-d32 test-isgreater-d64 test-isgreater-d128 \
		 test-isgreaterequal-d32 test-isgreaterequal-d64 test-isgreaterequal-d128 \
		 test-isless-d32 test-isless-d64 test-isless-d128 \
		 test-islessequal-d32 test-islessequal-d64 test-islessequal-d128 \
		 test-rint-d32 test-rint-d64 test-rint-d128 \
		 test-lround-d32 test-lround-d64 test-lround-d128 \
		 test-llround-d32 test-llround-d64 test-llround-d128 \
		 test-lrint-d32 test-lrint-d64 test-lrint-d128 \
		 test-llrint-d32 test-llrint-d64 test-llrint-d128 \
		 test-isnormal-d32 test-isnormal-d64 test-isnormal-d128 \
		 test-signbit-d32 test-signbit-d64 test-signbit-d128 \
		 test-fmin-d32 test-fmin-d64 test-fmin-d128 \
		 test-fmax-d32 test-fmax-d64 test-fmax-d128 \
		 test-fdim-d32 test-fdim-d64 test-fdim-d128 \
		 test-isunordered-d32 test-isunordered-d64 test-isunordered-d128 \
		 test-islessgreater-d32 test-islessgreater-d64 test-islessgreater-d128 \
		 test-ldexp-d32 test-ldexp-d64 test-ldexp-d128 \
		 test-fmaxmag-d32 test-fmaxmag-d64 test-fmaxmag-d128 \
		 test-fminmag-d32 test-fminmag-d64 test-fminmag-d128 \
		 test-math-macros test-strfrom \
		 test-nextup-d32 test-nextup-d64 test-nextup-d128 \
		 test-nextdown-d32 test-nextdown-d64 test-nextdown-d128

ifeq ($(libdfp-has-timode),yes)
libdfp_c_tests += test-fix test-float
endif

include $(top_srcdir)/tests/Makefile.autotest

libdfp_c_autotests = $(foreach test, $(libdfp-auto-tests), $(foreach type, d32 d64 d128, test-$(test)-$(type)))

$(addsuffix .out,$(libdfp_c_autotests)) : test-extra-opts += -u $(basename $^).ulp

libdfp_c_tests += $(libdfp_c_autotests)

test-%-d%: $(addsuffix .os,$@)
	$(CC) $(CFLAGS) $(sysdeps-CFLAGS) $(GLIBC_LIBS) -L$(top_builddir)/ -ldfp $(top_builddir)/$^ -o $@
test-%-d32.c: %.input
	$(PYTHON) $(top_srcdir)/tests/gen-libdfp-tests.py -t decimal32 $^ > $(top_builddir)/$@
test-%-d64.c: %.input
	$(PYTHON) $(top_srcdir)/tests/gen-libdfp-tests.py -t decimal64 $^ > $(top_builddir)/$@
test-%-d128.c: %.input
	$(PYTHON) $(top_srcdir)/tests/gen-libdfp-tests.py -t decimal128 $^ > $(top_builddir)/$@

ulps-file = $(shell find $(sysdep_dirs:%=$(top_srcdir)/%/) \
			 -name libdfp-test-ulps | head -1)

libdfp-test-ulps.h: $(ulps-file)
	$(PYTHON) $(top_srcdir)/tests/gen-libdfp-ulps.py $< -o $@

# Add the ULP file generation explicity rule
$(addprefix $(objpfx), $(libdfp_c_tests)): $(top_builddir)/libdfp-test-ulps.h

regen-ulps:
	for i in $(libdfp-auto-tests); do \
	  echo "test $$i"; \
	  cat test-$$i-*.ulp; \
	  echo; \
	done > ulps
.PHONY: regen-ulps

=== sysdeps/bid/Makefile ===
# Copyright (C) 2015 Free Software Foundation, Inc.
#
# This file is part of the Decimal Floating Point C Library.
#
# The Decimal Floating Point C Library is free software; you can
# redistribute it and/or modify it under the terms of the GNU Lesser
# General Public License version 2.1.
#
# The Decimal Floating Point C Library is distributed in the hope that
# it will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
# the GNU Lesser General Public License version 2.1 for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License version 2.1 along with the Decimal Floating Point C Library;
# if not, write to the Free Software Foundation, Inc., 51 Franklin
# Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please see libdfp/COPYING.txt for more information.  */

libdfp_files += bid-private binpowof10 decpowof2

ifeq ($(libdfp-has-timode),yes)
libdfp_files += ticonstants
endif

=== sysdeps/soft-dfp/bid/Makefile ===
# Copyright (C) 2015 Free Software Foundation, Inc.
#
# This file is part of the Decimal Floating Point C Library.
#
# The Decimal Floating Point C Library is free software; you can
# redistribute it and/or modify it under the terms of the GNU Lesser
# General Public License version 2.1.
#
# The Decimal Floating Point C Library is distributed in the hope that
# it will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
# the GNU Lesser General Public License version 2.1 for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License version 2.1 along with the Decimal Floating Point C Library;
# if not, write to the Free Software Foundation, Inc., 51 Franklin
# Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please see libdfp/COPYING.txt for more information.  */

# Empty Makefile so that Versions file is picked up by the build machinery
# only searches for Versions files where it finds Makefiles.

=== debian/changelog ===
libdfp (1.0.17-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release. Closes: ##1077413.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Sat, 13 Dec 2025 16:52:16 +0100

=== debian/control ===
Source: libdfp
Priority: optional
Maintainer: Frédéric Bonnard <frediz@debian.org>
Uploaders: Matthias Klose <doko@ubuntu.com>
Build-Depends: debhelper-compat (= 13), gawk, python3
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/libdfp/libdfp
Vcs-Git: https://salsa.debian.org/debian/libdfp.git
Vcs-Browser: https://salsa.debian.org/debian/libdfp
Section: libs

Package: libdfp-dev
Section: libdevel
Architecture: amd64 i386 s390x powerpc ppc64 ppc64el
Multi-Arch: same
Depends: libdfp1 (= ${binary:Version}), ${misc:Depends}
Description: decimal floating point library (runtime)
 The "Decimal Floating Point C Library" is an implementation of ISO/IEC
 Technical report  "ISO/IEC TR 24732" which describes the C-Language library
 routines necessary to provide the C library runtime support for decimal
 floating point data types introduced in IEEE 754-2008, namely _Decimal32,
 _Decimal64, and _Decimal128.
 .
 This package contains the development files.

Package: libdfp1
Architecture: amd64 i386 s390x powerpc ppc64 ppc64el
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: decimal floating point library (development files)
 The "Decimal Floating Point C Library" is an implementation of ISO/IEC
 Technical report  "ISO/IEC TR 24732" which describes the C-Language library
 routines necessary to provide the C library runtime support for decimal
 floating point data types introduced in IEEE 754-2008, namely _Decimal32,
 _Decimal64, and _Decimal128.
 .
 This package contains the runtime shared library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_STRIP = -Wl,-Bsymbolic-functions

DERIVATIVE := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
                elif dpkg-vendor --derives-from Debian; then echo Debian; \
                else echo Unknown; fi)

ifeq ($(DERIVATIVE),Ubuntu)
  ifeq ($(DEB_HOST_ARCH),ppc64el)
	cpu = --with-cpu=power9
  else ifeq ($(DEB_HOST_ARCH),s390x)
	cpu = --with-cpu=z15
  endif
else # Debian
  ifeq ($(DEB_HOST_ARCH),ppc64el)
	cpu = --with-cpu=power8
  else ifeq ($(DEB_HOST_ARCH),s390x)
	cpu = --with-cpu=zEC12
  endif
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --enable-decimal-float=yes $(cpu)
